//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Entities;

namespace Client.Test
{
    public abstract class ClientEntitySet : IClientEntitySet
    {
    	public ClientEntitySet(NorthwindClientContext context, IList entities, Func<IObjectWithChangeTracker, object> getEntityKey)
    	{
    		Context = context;
    		Entities = entities;
    		GetEntityKey = getEntityKey;
    	}
    
    	public NorthwindClientContext Context { get; private set; }
    	protected IList Entities { get; private set; }
    	public Func<IObjectWithChangeTracker, object> GetEntityKey { get; private set; }
    	
    	private bool _isLoaded;
    	bool IClientEntitySet.IsLoaded 
    	{ 
    		get { return _isLoaded; } 
    		set { _isLoaded = value; }
    	}
    	
    	private bool _lazyLoadingEnabled = true;
    	public bool LazyLoadingEnabled 
    	{ 
    		get { return (Context.LazyLoadingEnabled ?? true) && _lazyLoadingEnabled; } 
    		set { _lazyLoadingEnabled = value; }
    	}
    
        protected virtual void Add(IObjectWithChangeTracker entity)
        {
    		entity.ChangeTracker.ChangeTrackingEnabled = true;
    		entity.ChangeTracker.State = ObjectState.Added;
    		AddEntity(entity);
        }
    
        protected virtual void Attach(IObjectWithChangeTracker entity)
        {
    		entity.ChangeTracker.AcceptChanges();
    		entity.ChangeTracker.ModifiedProperties.Clear();
    		entity.ChangeTracker.ChangeTrackingEnabled = true;
    		AddEntity(entity);
        }
    
    	private void AddEntity(IObjectWithChangeTracker entity)
    	{
    		if (Entities.Contains(entity))
    			return;
    		var entityKey = GetEntityKey(entity);
    		if (Entities.Cast<IObjectWithChangeTracker>().Any(e => GetEntityKey(e).Equals(entityKey)) && !(entity.HasKeyIdentityOrComputed && entity.ChangeTracker.State == ObjectState.Added))
    			throw new InvalidOperationException("Another entity with the same key already exists in the context");
    		Entities.Add(entity);
    	}
    
        protected virtual void Remove(IObjectWithChangeTracker entity)
        {
    		if (entity.ChangeTracker.State == ObjectState.Added)
    			Detach(entity);
    		else
    	        entity.ChangeTracker.State = ObjectState.Deleted;
        }
    
        protected virtual void Detach(IObjectWithChangeTracker entity)
        {
            Entities.Remove(entity);
    		entity.ChangeTracker.State = ObjectState.Detached;
        }
    
    	void IClientEntitySet.Add(IObjectWithChangeTracker entity)
    	{
    		AddEntity(entity);
    	}
    
    	void IClientEntitySet.Attach(IObjectWithChangeTracker entity)
    	{
    		Attach(entity);
    	}
    
    	void IClientEntitySet.Remove(IObjectWithChangeTracker entity)
    	{
    		Remove(entity);
    	}
    
    	void IClientEntitySet.Detach(IObjectWithChangeTracker entity)
    	{
    		Detach(entity);
    	}
    
    	bool IClientEntitySet.AttachWithoutChangingState(IObjectWithChangeTracker entity)
    	{
    		if (Entities.Contains(entity))
    			return false;
            if (entity.ChangeTracker.State == ObjectState.Detached)
            {
                entity.ChangeTracker.ChangeTrackingEnabled = true;
                entity.ChangeTracker.State = ObjectState.Added;
            }
    		AddEntity(entity);
    		return true;
    	}
        public virtual int Count
        {
            get 
    		{ 
               var enumerator = GetEnumerable().GetEnumerator();
               int value = 0;
               while (enumerator.MoveNext()) value++;
               return value; 
    		}
        }
    
        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerable().GetEnumerator();
        }
    	protected virtual IEnumerable GetEnumerable()
    	{
    		if ((Context.LazyLoadingEnabled ?? false) && ! _isLoaded)
    		{
    			var enumerable = (IEnumerable)typeof(EntitySetExtension).GetMethods().First(m => m.Name == "AsQueryable" && m.GetParameters().Length == 1 && m.GetParameters()[0].ParameterType == typeof(ClientEntitySet<>).MakeGenericType(GetEntityType())).Invoke(null, new object[]{ this });
    			if (Context.MergeOption == MergeOption.NoTracking)
    				return enumerable;
    			var enumerator = enumerable.GetEnumerator();
    			while (enumerator.MoveNext());
    		}
            return Entities.OfType<IObjectWithChangeTracker>().Where(e => e.ChangeTracker.State != ObjectState.Deleted);
    	}
    	protected abstract Type GetEntityType();
    }
    
    public class ClientEntitySet<T> : ClientEntitySet, IEnumerable<T>
    	where T : IObjectWithChangeTracker
    {
    	public ClientEntitySet(NorthwindClientContext context, Func<T, object> getEntityKey)
            : base(context, new List<T>(), e => getEntityKey((T)e))
    	{
    	}
    
    	public List<T> AllEntities
    	{
    		get { return (List<T>)Entities; }
    	}
    
        public virtual void Add(T entity)
        {
            base.Add(entity);
            OnEntityAdded(entity);
        }
    
    	public virtual void Attach(T entity)
    	{
    		base.Attach(entity);
            OnEntityAttached(entity);
    	}
    
        public virtual void Remove(T entity)
        {
            OnEntityRemoving(entity);
    		base.Remove(entity);
            OnEntityRemoved(entity);
        }
    
    	public virtual void Detach(T entity)
    	{
    		base.Detach(entity);
            OnEntityDetached(entity);
    	}
    
        protected virtual void OnEntityAdded(T entity)
        {
            if (EntityAdded != null)
                EntityAdded(entity);
        }
        public event Action<T> EntityAdded;
    
        protected virtual void OnEntityAttached(T entity)
        {
            if (EntityAttached != null)
                EntityAttached(entity);
        }
        public event Action<T> EntityAttached;
    
        protected virtual void OnEntityRemoving(T entity)
        {
            if (EntityRemoving != null)
                EntityRemoving(entity);
        }
        public event Action<T> EntityRemoving;
    
        protected virtual void OnEntityRemoved(T entity)
        {
            if (EntityRemoved != null)
                EntityRemoved(entity);
        }
        public event Action<T> EntityRemoved;
    
        protected virtual void OnEntityDetached(T entity)
        {
            if (EntityDetached != null)
                EntityDetached(entity);
        }
        public event Action<T> EntityDetached;
    
        public virtual T this[int index]
        {
            get { return (T)Entities[index]; }
        }
    
    	public IEnumerator<T> GetEnumerator()
        {
            return GetEnumerable().Cast<T>().GetEnumerator();
        }
    	
    	protected override Type GetEntityType()
    	{
    		return typeof(T);
    	}
    }}
